''  con_buf.bas
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "con_buf.bi"

#define TRUE  1
#define FALSE 0

Sub conbuf_clear( ByVal conbuffer As CONBUFFER_T Ptr )
	If (conbuffer) Then
		Dim p As UByte Ptr = conbuffer->dataptr
		If (p) Then
			Dim count As Integer = conbuffer->size
			Do while (count)
				count -= 1
				*p = 0
				p += 1
			Loop
		End If
		conbuffer->col = 0
		conbuffer->row = 0
		conbuffer->changed = TRUE
	End If
End Sub

Sub conbuf_text( ByVal conbuffer As CONBUFFER_T Ptr, ByVal txt As UByte ptr )
	Dim c As UByte Ptr = txt
	Dim cr As Integer = FALSE
	conbuffer->changed = TRUE

	Do while(*c)
		Select Case (*c)
			case 13
				conbuffer->col = 0
				cr = TRUE
			case 10
				conbuffer->col = 0
			case else
				conbuffer->dataptr[conbuffer->row * conbuffer->maxcol + conbuffer->col] = *c
				conbuffer->col += 1
				if(conbuffer->col>=conbuffer->maxcol) Then
					conbuffer->col=0
					cr = TRUE
				end if
		End Select

		if(cr) Then
			cr = FALSE
			conbuffer->row += 1      
			if (conbuffer->row >= conbuffer->maxrow) Then
				Dim dst As UByte Ptr = conbuffer->dataptr
				Dim src As UByte Ptr = conbuffer->dataptr + conbuffer->maxcol
				Dim count As Integer = (conbuffer->maxrow-1)*conbuffer->maxcol
				Do while (count)
					count -= 1
					*dst = *src
					dst += 1
					src += 1
				Loop
				count = conbuffer->maxcol
				Do while (count)
					count -= 1
					*dst = 0
					dst += 1
				Loop
				conbuffer->row -= 1
			End If
		End If
		c += 1
	Loop
End Sub

Function conbuf_resize( ByVal conbuffer As CONBUFFER_T Ptr, ByVal rows As Integer, Byval cols As Integer)
	''FIXME: preserve data
	conbuffer->maxrow = rows
	conbuffer->maxcol = cols
	conbuf_clear conbuffer
	Function = TRUE
End Function
