''  jm_con.bas
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_con.bi"
#include "con_buf.bi"

'' Allocate some space for the console
#define DEFMAXROW   20
#define DEFMAXCOL   40
#define DEFCONSIZE  DEFMAXROW * DEFMAXCOL

#define TRUE  1
#define FALSE 0

Dim Shared defcon As CONBUFFER_T Ptr

Dim Shared conechoflag As Integer = FALSE  '' by default, do not echo to system console
Dim Shared condebugflag As Integer = FALSE '' by default, do not print debug messages

Dim shared logfile As String
Dim shared logenabled as integer

Sub jm_con_init () Constructor
	dim defcondata as UByte Ptr
	defcon = Allocate(sizeof(CONBUFFER_T))
	if defcon Then
		defcondata = Allocate(DEFCONSIZE)
		defcon->maxrow  = DEFMAXROW
		defcon->maxcol  = DEFMAXCOL
		defcon->row     = 0
		defcon->col     = 0
		defcon->size    = DEFCONSIZE
		defcon->changed = TRUE
		defcon->dataptr = defcondata
		CON_clear
	End If
	logfile = ""
	logenabled = FALSE
End Sub

Sub jm_con_exit () Destructor
	If (defcon) Then
		If (defcon->dataptr) Then
			Deallocate defcon->dataptr
		End If
		Deallocate defcon
	End If
End Sub

Function CON_getecho(  ) As Integer
	return(conechoflag)
End Function

Function CON_setecho( ByVal flag As Integer) As Integer
	Dim oldflag As Integer = conechoflag
	conechoflag = flag
	return(oldflag)
End Function

Function CON_getdebug(  ) As Integer
	return(condebugflag)
End Function

Function CON_setdebug( ByVal flag As Integer ) As Integer
	Dim oldflag As Integer = condebugflag
	condebugflag = flag
	return(oldflag)
End Function

Sub CON_setlogfile( f As String)
	logfile = f
	if logfile > "" then
		logenabled = TRUE
	else
		logenabled = FALSE
	endif
End Sub

Function CON_getlogfile() As String
	CON_getlogfile = logfile
End Function
	

Sub CON_clear( )
	conbuf_clear defcon
End Sub

Sub CON_printf(txt As String)
	if (conechoflag) Then
		print txt;
	End If

	conbuf_text defcon, StrPtr(txt)

	If logenabled then
		dim h as integer
		h = freefile
		open logfile for append as #h
		print #h, txt;
		close #h
	End If

End Sub

Sub CON_printf_dbg(txt As string)

	if (condebugflag = 0) Then
		exit sub
	End If

	if (conechoflag) Then
		print txt;
	End If

	conbuf_text defcon, StrPtr(txt)

	If logenabled then
		dim h as integer
		h = freefile
		open logfile for append as #h
		print #h, txt;
		close #h
	End If
End Sub


Function CON_data( ) As UByte Ptr
	if (defcon) Then
		defcon->changed = FALSE
		return( defcon->dataptr )
	End If
End Function

Function CON_maxrow( ) As Integer
	return( defcon->maxrow )
End Function

Function CON_maxcol( ) As Integer
	return( defcon->maxcol )
End Function

Function CON_resize(ByVal cols As Integer, ByVal Rows As Integer) As Integer
	Dim tmpcondata As UByte ptr
	Dim tmpcon As CONBUFFER_T Ptr 
	
	If (cols > 0) And (cols <= 80) And (rows > 0) And (rows <= 50) Then
		tmpcon = Allocate(sizeof(CONBUFFER_T))
		if (tmpcon) Then
			tmpcondata = Allocate(DEFCONSIZE)
			if (tmpcondata) Then
				tmpcon->maxrow  = rows
				tmpcon->maxcol  = cols
				tmpcon->row     = 0
				tmpcon->col     = 0
				tmpcon->size    = rows * cols
				tmpcon->changed = TRUE
				tmpcon->dataptr = tmpcondata
				'' FIXME: preserve data between resize (copy)
				If (defcon) Then
					If (defcon->dataptr) Then
						Deallocate defcon->dataptr
					End If
					Deallocate defcon
				End If
				defcon = tmpcon
				CON_clear
				return 1
			Else
				Deallocate tmpcon
			End If
		End If
	End If
	return 0
End Function
