Option Explicit

#include "fbgfx.bi"
#include "jm_font.bi"

' ==================
' Mini Scroll Buffer
' ==================

Dim Shared gTxt(0 to 24) as String
Dim Shared gTxtHead as Integer = 0
Dim Shared gTxtTail as Integer = 0

Sub AddBufferLine(txt as string)
	gTxt(gTxtTail) = txt
	gTxtTail = (gTxtTail + 1) Mod 25
	If gTxtTail = gTxtHead Then
		gTxtHead = (gTxtHead + 1) Mod 25
	End If
End Sub

Sub DrawScrollBuffer(x as integer, y as integer, foreColor as Integer)
	Dim i as Integer, yy as Integer, fnt As JM_FONT_T Ptr
	fnt = FONT_Get()
	i = gTxtHead
	yy = y
	Do While i <> gTxtTail
		FONT_DrawString x, yy, gTxt(i), foreColor, 0
		i = (i + 1) Mod 25
		yy += fnt->h
	Loop
End Sub

Sub DrawMouse (x as Integer, y as Integer)
	Line (x-10,y)-(x+10,y), rgb(255,255,255)
	Line (x,y-10)-(x,y+10), rgb(255,255,255)
End Sub

Sub DrawFly (x as Integer, y as Integer, foreColor as Integer)
	Circle (x,y), 5, foreColor
	Circle (x,y), 7, foreColor
	Circle (x,y), 8, foreColor
End Sub

' ================
' Main
' ================

Dim x As Integer, y As Integer, k As String
Dim mx as Integer, my as Integer
Dim t as single, t1 as single, t2 as single
Dim flyx As Single, flyy As Single
Dim flydist as Single, FlyClr as Single
Dim barAng as Single, barx as Integer, prevBarX as Integer
Dim pi as Single, extraTimer as Single
Dim fnt As JM_FONT_T Ptr

ScreenRes 640, 480, 24, 2  ' 640 x 480 x 24 bit x 2 pages
ScreenSet 1, 0             ' Set working page / active page
fnt = FONT_CreateFromBMP(6, 6, "data\6x6.bmp")
FONT_Set fnt
SetMouse 320, 240, 0       ' Set Mouse to screen center and hide cursor

flyx = 100
flyy = 100
barAng = 0

pi = 3.14159

t1 = Timer
Do
	t2 = Timer
	t = t2 - t1
	t1 = t2

	GetMouse mx, my
	k = Inkey

	extraTimer = extraTimer + t
	If extraTimer > 0.5 Then
		extraTimer = 0
		AddBufferLine "Current Position is ("+Str(mx)+","+Str(my)+")"
	Endif

	barAng += t 
	if barAng > pi * 2 then barAng -= pi * 2
	prevBarX = barX
	barX = sin(barAng) * 320 + 320
	flyClr = flyClr - t * 100
	if flyClr < 5 then flyClr = 5

	If (prevBarX >= flyX and barX <= flyX) OR (barX >= flyX And prevBarX <= flyX) Then
		flyClr = 255
		AddBufferLine "Fly pinged at ("+Str(flyX)+","+Str(flyY)+")"
	Endif

	flyx += (CSng(mx) - flyx) * t
	flyy += (CSng(my) - flyy) * t
	flydist = Sqr( Abs( (flyx - mx) * (flyx - mx) + (flyy - my) * (flyy - my) ) )

	' Render the screen
	Cls
		Line (0,0)-(639,479),rgb(0,63,0),bf
		Line (barX-5,0)-(barX+5,479), rgb(0,191,0), bf
		DrawScrollBuffer 321, 0, rgb(255, 255, 0)

		FONT_DrawString CInt(flyx) + 4, CInt(flyy) - 12, Str(CInt(flyx)) + "," + Str(CInt(flyy)), rgb(127,127,255), 0
		DrawFly CInt(flyx), CInt(flyy), rgb(0,flyClr,0)

		FONT_DrawString mx + 4, my - 12, Str(mx) + "," + Str(my), rgb(127,127,255), 0
		DrawMouse mx, my

		Line (mx,my) - (flyx, flyy), rgb(255, 127, 0)
	Flip                      ' Switch working / active page
	Sleep 1                   ' Play nice with Operating System
Loop Until MultiKey(1)      ' Until ESCAPE key is pressed

' Clean Up
FONT_Delete fnt
Screen 0
End 0
