''  jm_font.bas - jm_font
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_font.bi"

Dim Shared FONT_curfnt As JM_FONT_T Ptr

Function FONT_CreateFromBMP(ByVal w As Integer, ByVal h As Integer, strFile As String) As JM_FONT_T Ptr
	Dim tmp As Any Ptr, fnt As JM_FONT_T Ptr = 0
	tmp = ImageCreate(w * 16, h * 16)
	if (tmp) Then
		if Bload(strFile, tmp) = 0 then
			'' FIXME: On Fail, cleanup And return NULL
			fnt = FONT_CreateFromImage(w, h, tmp)
		end if
		ImageDestroy tmp
	End If
	return fnt
End Function

Function FONT_Get() As JM_FONT_T Ptr
	Return FONT_curfnt
End Function

Function FONT_Set(fnt As JM_FONT_T Ptr) As JM_FONT_T Ptr
	Dim lstfnt As JM_FONT_T Ptr
	lstfnt = FONT_curfnt
	FONT_curfnt = fnt
	Return lstfnt
End Function

' =================
' Text Metrics
' =================
''declare sub		 YagGfxFont_getTextDimensions cdecl alias "YaglGfxFont_getTextDimensions" ( byval font as YaglGfxFont, byval text as zstring ptr, byref width as unsigned integer, byref height as unsigned integer )

Function FONT_GetTextWidth overload(ByVal s As ubyte Ptr, ByVal nBytes As Integer) As Integer
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	If (fnt) Then
		function = nBytes * fnt->w
	End If
End Function

Function FONT_GetTextHeight overload(ByVal s As ubyte Ptr, ByVal nBytes As Integer) As Integer
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	If (fnt) Then
		function = fnt->h
	End If
End Function

Function FONT_GetTextWidth(s as string) As Integer
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	If (fnt) Then
		function = len(s) * fnt->w
	End If
End Function

Function FONT_GetTextHeight(s as string) As Integer
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	If (fnt) Then
		function = fnt->h
	End If
End Function

' =================
' STRING DRAWING
' =================

Sub FONT_DrawString(ByVal x as Integer, ByVal y as Integer, ByVal txt as ubyte Ptr, ByVal nBytes As Integer, ByVal foreColor as Integer, ByVal backColor as Integer, ByVal Trans as integer)
	Dim xx as Integer, i As Integer, n As Integer, ch as integer
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	if (fnt->typ = 0) then '' Bitmap - FIXME: use constant
		if nBytes > 0 then
			n = nBytes
		else
			n = Len(*txt)
		end if
		xx = x
		if (trans) then
			backcolor = -1
		endif
		For i = 0 to n - 1
			ch = txt[i]
			FONT_DrawChar xx, y, ch, foreColor, backColor
			xx += fnt->w
		Next i
	else
		#ifdef YAGL
			FONT_DrawTTF(x,y,txt,nBytes,forecolor,backcolor,trans)
		#endif
	end if
End Sub

