''  jm_font_fbgfx.bas - jm_font
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_font.bi"

' =================
' Font Creation
' =================

Function FONT_CreateFromImage(ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_T Ptr
	Dim i as Integer, tmp as Any Ptr, sx As Integer, sy As Integer, chptr As Any Ptr
	dim bpp as integer, j as integer
	Dim fnt As JM_FONT_T Ptr
	fnt = Allocate(sizeof(JM_FONT_T))
	fnt->typ = 0 '' Bitmap - FIXME: replace with constant
	fnt->w = w
	fnt->h = h
	fnt->tmpch = ImageCreate(w, h)
	bpp = (*Cast(UShort Ptr, fnt->tmpch) And 7)
	fnt->bpc = (((bpp * w * h) + 3) And (Not 3)) + 4
	fnt->chdata = Allocate(256 * fnt->bpc)
	fnt->handle = 0
	For i = 0 to 255
		chptr = Cast(Byte Ptr,fnt->chdata) + i * fnt->bpc
		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		Get img, (sx, sy)-(sx + w-1,sy + h-1), chptr
		'' fixup for <= 8 bit modes
		if bpp = 1 then
			for j = 0 to w * h - 1
				if (Cast(Ubyte Ptr, chptr)[j + 4]) then
					Cast(Ubyte Ptr, chptr)[j + 4] = 255
				end if
			next j
		end if
	Next i
	Return fnt
End Function

Sub FONT_Delete(fnt As JM_FONT_T Ptr)
	Dim i as Integer
	If (fnt) Then
		deallocate fnt->chdata
		fnt->w = 0
		fnt->h = 0
		fnt->bpc = 0
		ImageDestroy fnt->tmpch
		fnt->handle = 0
	End If
End Sub

' =================
' Character Drawing
' =================

Sub FONT_DrawChar (ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal fc as Integer, ByVal bc as Integer)
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	dim chptr as any ptr
	If (fnt) Then
		If (fnt->chdata) then
			chptr = Cast(byte ptr, fnt->chdata) + fnt->bpc * (ch and 255)
			if bc = -1 then
				line fnt->tmpch, (0,0)-(fnt->w-1,fnt->h-1),not fc, bf
				Put fnt->tmpch, (0, 0), chptr, and
				Put (x, y), chptr, or
				Put (x, y), fnt->tmpch, xor
			else
				line fnt->tmpch, (0,0)-(fnt->w-1,fnt->h-1),not fc, bf
				Put fnt->tmpch, (0, 0), chptr, and
				Line (x,y)-(x + fnt->w - 1, y + fnt->h - 1), bc, bf
				Put (x, y), chptr, or
				Put (x, y), fnt->tmpch, xor
			end if
		End If
	End If
End Sub

