''  jm_font_yagl.bas - jm_font
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_font.bi"
#include "yaglwrapper.bi"

#define mBLEND 1.0

' =================
' Font Creation
' =================

Function FONT_CreateFromImage(ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_T Ptr
	Dim as Integer i, j, sx, sy
	Dim tmp as Any Ptr, chptr As YaglGfxSurface Ptr, c as integer ptr
	Dim fnt As JM_FONT_T Ptr
	Dim t As Any Ptr = ImageCreate(w, h)
	fnt = Allocate(sizeof(JM_FONT_T))
	fnt->typ = 0
	fnt->w = w
	fnt->h = h
	fnt->bpc = 0    '' not used for yagl
	fnt->chdata = Allocate(256 * sizeof(YaglGfxSurface))
	fnt->tmpch = 0  '' not used for yagl
	For i = 0 to 255
		chptr = Cast(YaglGfxSurface Ptr,fnt->chdata) + i
		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		Get img, (sx, sy)-(sx + w-1,sy + h-1), t
		c = t
		for j = 1 to w*h
			if (c[j]) then	c[j] OR= &HFF000000
		next j				
		*chptr = YaglGfxDevice_createSurface()
		YaglGfxSurface_loadFromMemory(*chptr, Cast(byte ptr, t) + 4, w, h, BITMAP_FORMAT_ARGB32)
	Next i
	ImageDestroy t
	Return fnt
End Function


Function FONT_CreateFromTTF(ByVal w As Integer, ByVal h As Integer, strFile As String) As JM_FONT_T Ptr
	Dim fnt As JM_FONT_T Ptr
	fnt = Allocate(sizeof(JM_FONT_T))
	fnt->typ = 1    '' TTF Font - FIXME: Use constant
	fnt->w = w
	fnt->h = h
	fnt->bpc = 0    '' not used for yagl
	fnt->chdata = 0
	fnt->tmpch = 0  '' not used for yagl
	fnt->handle = YaglGfxDevice_CreateFont
	YaglGfxFont_loadFont(fnt->handle, @strFile[0])
	YaglGfxFont_setSize(fnt->handle, h)
	return fnt
End Function

Sub FONT_Delete(fnt As JM_FONT_T Ptr)
	Dim i as Integer, chptr As YaglGfxSurface Ptr
	If (fnt) Then
		If fnt->chdata Then
			For i = 0 to 255
				YaglGfxDevice_destroySurface *(Cast(YaglGfxSurface Ptr,fnt->chdata) + i)
			Next i
			deallocate fnt->chdata
			fnt->chdata = 0 '' NULL
		end if
		fnt->w = 0
		fnt->h = 0
	End If
End Sub

' =================
' Character Drawing
' =================

Sub FONT_DrawChar (ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal foreColor as Integer, ByVal backColor as Integer)
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	If (fnt) Then
		If (fnt->chdata) Then
			YaglGfxDevice_blit x, y, *(Cast(YaglGfxSurface Ptr,fnt->chdata) + (ch AND 255)), BLIT_ALPHAMASKED, mBLEND
		End If
	End If
End Sub

Sub FONT_DrawSolidChar (ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal foreColor as Integer, ByVal backColor as Integer)
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt
	If (fnt) Then
		If (fnt->chData) Then
			YaglGfxDevice_blit x, y, *(Cast(YaglGfxSurface Ptr,fnt->chdata) + (ch AND 255)), BLIT_SOLID, mBLEND
		End If
	End If
End Sub

Sub FONT_DrawTTF(ByVal x as Integer, ByVal y as Integer, _ 
	ByVal txt as ubyte Ptr, ByVal nBytes As Integer, _
	ByVal foreColor as Integer, ByVal backColor as Integer, ByVal Trans as integer)
	Dim xx as Integer, i As Integer, n As Integer, ch as integer
	Dim fnt As JM_FONT_T Ptr = FONT_curfnt

	if nBytes > 0 then
		n = nBytes
	else
		n = Len(*txt)
	end if
	YaglGfxDevice_printAt @txt[0], x, y,foreColor,fnt->handle,1.0

End sub