''  guidemo.bas
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_gui.bi"
#include "jm_gui_input.bi"
#include "jm_gui_keys.bi"
#include "jm_boxes.bi"
#include "jm_boxes_std.bi"
#include "../jm_font/jm_font.bi"
#include "../jm_con/jm_con.bi"

#ifdef __FB_DOS__
Declare Sub jm_gfx_update cdecl alias "jm_gfx_update" ()
#endif

Dim Shared As UI_BOX_PTR gRoot, gOptions, gTest1, gTest2, gConsole,gCapRate
Dim Shared fnt As JM_FONT_T Ptr	= 0
Dim Shared gQuit As Integer	= 0
Dim Shared gVidSync As Integer = 0, gLastKey As Integer = 0
Dim Shared As Integer gScreenW=0, gScreenH=0,gScreenD=0, gScreenF=0

Type TIMER_T
	count as integer
	t1 as double
	t2 as double
	valid as integer
	percount as integer
	rate as integer
end type

sub Timer_Init(tmr as TIMER_T)
	with tmr
		.count = 0
		.t1 = timer
		.t2 = .t1
		.valid = 0
	end with
end sub

sub Timer_Reset(tmr as TIMER_T)
	with tmr
		if .count > 0 then
			.percount = int((cdbl(.t2) - cdbl(.t1)) / cdbl(.count) * 1000)
		else
			.percount = 0
		endif
		if (cdbl(.t2) - cdbl(.t1)) > 0 then
			.rate = int(cdbl(.count) / (cdbl(.t2) - cdbl(.t1)))
		else
			.rate = 0
		end if
		.count = 0
		.t1 =.t2
		.valid = 0
	end with
end sub

sub Timer_Accum(tmr as TIMER_T, byval tdiff as double)
	with tmr
		.count += 1
		.t2 += tdiff
	end with
end sub

sub Timer_Update(tmr as TIMER_T)
	with tmr
		.count += 1
		.t2 = timer
		if .t2 - .t1 > 1.0 then
			.valid = 1
		end if
	end with
end sub


#ifdef YAGL
	#print Using YAGL
	#include "yaglwrapper.bi"
	Dim Shared gsurface as YaglGfxSurface = 0
#else
	#print Using FBGFX
#endif

'' --------------------------------------------------------------------------
'' PRIVATE FUNCTIONS
'' --------------------------------------------------------------------------

Sub Draw_Con(ByVal xx As Integer, ByVal yy As Integer)
	Dim c As UByte Ptr
	Dim As Integer x, y, w, h

	c = CON_data()
	If (c) Then
		w = CON_maxcol()
		h = CON_maxrow()
	
		'If (bk) Then
		'	For y = 0 to h - 1
		'		For x = 0 to w - 1
		'			put (xx + x * fnt->w, yy + y * fnt->h), bk, alpha
		'		Next j
		'	Next i
		'End If

		For y = 0 to h - 1
			For x = 0 to w - 1
				FONT_DrawChar xx + x * fnt->w, yy + y * fnt->h, CInt(c[y * w + x]),UI_GetSysColor(STSCLR_TEXT_BACK), UI_GetSysColor(SYSCLR_TEXT)
			Next j
		Next i

	End If

End Sub

Function CON_print(txt As String) As integer
	Dim a As string
	a = txt & chr(13) & chr(10)
	CON_printf(a)
	return 0
End Function

Function CON_print_dbg(txt As String) As integer
	If (CON_getdebug()) Then
		Dim a As string
		a = txt & chr(13) & chr(10)
		CON_printf(a)
	End If
	return 0
End Function

Sub Draw_BackGround
	''Dim x As Integer, y As Integer, c As Integer
	''Dim m1 As Double, m2 As Double, m3 As Double
	''For x = 0 to 639
	''	For y = 0 to 479
	''		m1 = Abs(Sin(CDbl(x) / 640 * 25) * Sin(CDbl(y) / 480 * 25)) * 128 + 32
	''		m2 = Abs(Sin(CDbl(x + 1) / 640 * 55) * Sin(CDbl(y - x) / 480 * 95)) * 128 + 32
	''		m3 = Abs(Sin(CDbl(x + y) / 640 * 85) * Sin(CDbl(y + 1) / 480 * 85)) * 128 + 32
	''		c = Rgb(m1, m2, m3)
	''		PSet (x,y), c
	''	Next y
	''Next x
	''ScreenCopy 0,1
End Sub

Sub UpdateCaption(ByVal owner As UI_BOX_PTR, ByVal id As Integer, txt As String)
	Dim cap As UI_BOX_PTR
	cap = UI_GetBoxFromID(owner, id)
	If (cap) Then
		UI_SetCaption(cap, txt)
	End If
End Sub

Sub ModeSet(ByVal w As integer, ByVal h As integer, Byval d As Integer, ByVal f As Integer)
	Dim As integer pw = gScreenW
	Dim As integer ph =	gScreenH
	Dim As integer pd =	gScreenD
	Dim As integer pf =	gScreenF
	DIm msg As String
	#ifdef YAGL
		if (gsurface) Then
			YaglGfxDevice_swapBuffers( )
		end if
	#endif

	''If (fnt <> 0) And (pd <> d) Then
	If (fnt <> 0) Then
		FONT_Delete fnt
		fnt = 0
	End If
	msg = "Switching to " & Str(w) & "x" & Ltrim(Str(h)) & "-" & Str(d) & "bit "
	If (f And 1) Then
	  msg = msg & "fullscreen"
	else
	  msg = msg & "windowed"
	End If
	CON_print(msg)

	#ifdef YAGL
	  if (gsurface) Then
			YaglGfxDevice_destroyAllSurfaces
			YaglGfxDevice_destroyAllFonts
		endif
		if( YaglGfxDevice_setScreenMode( w, h, d, f ) = 0 ) then
			CON_print("Unabled to switch mode")
			f = 0
			d = 16
			if( YaglGfxDevice_setScreenMode( w, h, d, f ) = 0 ) then
				CON_print("Unabled to switch to default mode")
			end if
		End if

		YaglGfxDevice_setWindowTitle( "guidemo_yagl demo" )
		gsurface = YaglGfxDevice_createSurface( )
		if( gsurface = 0 ) then
			CON_print("Unabled to createSurface")
		else
			gScreenW = w
			gScreenH = h
			gSCreenD = d
			gScreenF = f
		end if
	#else		
		#ifdef __FB_DOS__
			select case w
			case 320
				Screen 13,d,1
			case 640
				Screen 18,d,1
			case 800
				Screen 19,d,1
			case 1024
				Screen 20,d,1
			end select
			if ScreenPtr = 0 then
				screen 0
				print "Unable to set mode"
				end
			end if
		#else
			ScreenRes w,h,d,1,f
		#endif
		'' FIXME: Check success
		gScreenW = w
		gScreenH = h
		gSCreenD = d
		gScreenF = f
	#endif

	UI_Init
	UI_SetColorDepth gScreenD
	if (gScreenD = 8) then
		UI_SavePalette
	end if
	#ifdef YAGL
		if instr(lcase(command),"-ttf") > 0 then
			fnt = FONT_CreateFromTTF(6,8,"font.ttf")
			FONT_Set fnt
		else		
	#endif

		If (fnt = 0) Then
			''fnt = FONT_CreateFromBmp(6,8,"../jm_font/data/6x8.bmp")
			fnt = FONT_CreateFromBmp(6,8,"6x8.bmp")
			FONT_Set fnt
		End If

	#ifdef YAGL
		end if
	#endif

	if (gScreenD = 8) then
		UI_RestorePalette
	end if
End Sub

Sub DrawBackground
	#ifdef YAGL
		''YaglGfxDevice_clear rgb(63,31,95)
		YaglGfxDevice_solidbox 0,0,gScreenW-1, gScreenH-1, rgb(63,31,95), 255
	#else
		if gScreenD = 8 then '' FIXME
			line (0,0)-(gScreenW-1, gScreenH-1),1,bf
		else
			line (0,0)-(gScreenW-1, gScreenH-1),rgb(63,31,95),bf
		end if
	#endif
end sub

'' --------------------------------------------------------------------------
'' MAIN LOOP
'' --------------------------------------------------------------------------

Sub MainLoop
	Dim As Integer mx,my,mw,mb
	Dim As Double t1, t2,t3,t4
	Dim As TIMER_T tmr1,tmr2,tmr3,tmr4
	Dim ret As Integer
	Dim k As Integer, kp As String
  Timer_Init(tmr1)
  Timer_Init(tmr2)
  Timer_Init(tmr3)
  Timer_Init(tmr4)
	t1 = timer
	Do

		'' -----------------------------------------------
		'' INPUT/GUI
		'' -----------------------------------------------
#ifdef YAGL
		k = YaglKeyboard_getKey()
#else
		k = GetKeyCode()
#endif
		If k = KEY_CLOSE or k = KEY_F10 Then
			Exit Do
		End If
		If k <> KEY_NONE Then
			gLastKey = k
		End If
		If k = KEY_ESCAPE Then
			UI_ShowBox(gOptions)
		End If
#ifdef YAGL
		mx = YaglMouse_getX()
		my = YaglMouse_getY()
		mw = 0
		mb = YaglMouse_isLeftButtonPressed()
#else
		GetMouse mx, my, mw, mb
#endif
		If mx >= 0 and my >= 0 Then
			ret = UI_UpdateMouseInfo(gRoot, mx, my, mw, mb)
		End If
		if k <> KEY_NONE then
			UI_UpdateKeyInfo NULL, k
		end if

		if tmr1.valid then	
			Timer_Reset(tmr1)
			Timer_Reset(tmr2)
			Timer_Reset(tmr3)
			Timer_Reset(tmr4)
			UpdateCaption gTest1, 111, Str(tmr2.percount)
			UpdateCaption gTest1, 112, Str(Cint(tmr2.rate))
			UpdateCaption gTest1, 121, Str(tmr3.percount)
			UpdateCaption gTest1, 122, Str(Cint(tmr3.rate))
			UpdateCaption gTest1, 131, Str(tmr4.percount)
			UpdateCaption gTest1, 132, Str(Cint(tmr4.rate))
			UpdateCaption gTest1, 141, Str(tmr1.percount)
			UpdateCaption gTest1, 142, Str(Cint(tmr1.rate))
		  UpdateCaption gRoot, 1, Str(Cint(tmr1.rate))
		end if

	  UpdateCaption gOptions, 8, "VSync=" & Str(gVidSync)
	  UpdateCaption gOptions, 9, "LK=" & hex(gLastKey)

		t2 = Timer

		'' -----------------------------------------------
		'' DRAWING
		'' -----------------------------------------------

	  
		#ifdef YAGL
			DrawBackground
			ret = UI_Draw(gRoot, 0)
			t3 = Timer
			YaglGfxDevice_swapBuffers( )
		#else		
			#ifdef __FB_DOS__
				screenlock
				DrawBackground
				ret = UI_Draw(gRoot, 0)
				t3 = Timer
				jm_gfx_update
				If gVidSync Then
					screensync
				End If
				screenunlock
			#else
				screenlock
				DrawBackground
				ret = UI_Draw(gRoot, 0)
				t3 = Timer
				If gVidSync Then
					screensync
				End If
				screenunlock
			#endif
		#endif

		Sleep 1
		t4 = Timer
		Timer_Accum(tmr2, t2-t1)
		Timer_Accum(tmr3, t3-t2)
		Timer_Accum(tmr4, t4-t3)
		Timer_Update(tmr1)
		t1 = t4
	Loop Until gQuit = TRUE
End Sub

'' --------------------------------------------------------------------------
'' BOX PROCS
'' --------------------------------------------------------------------------

Function Options_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim d As UI_CHECK_T Ptr
	Select Case msgid
	Case UI_MSG_CREATE
		Select Case box->id
		Case 16
			d = UI_GetBoxDataPtr(box)
			''d->Checked = 1
		End Select
	Case UI_MSG_MOUSE_CLICK
		Select Case box->id
		Case 1
			UI_HideBox(gOptions)
		Case 2
			gQuit = TRUE
		Case 3
			UI_ShowBox(gTest1)
		Case 4
			UI_ShowBox(gTest2)
		Case 5
			ModeSet gScreenW,gScreenH,gScreenD,1
		Case 6
			ModeSet gScreenW,gScreenH,gScreenD,0
		Case 7
			d = UI_GetBoxDataPtr(box)
			gVidSync = d->Checked
		case 21
			ModeSet 320,200,gScreenD,gScreenF
			UI_PositionBox gOptions, 0, 0
			UI_PositionBox gTest2, 160, 0
			UI_PositionBox gTest2, 160, 0
			UI_PositionBox gConsole, 160, 100
		case 22
			ModeSet 640,480,gScreenD,gScreenF
		case 23
			ModeSet 800,600,gScreenD,gScreenF
		case 24
			ModeSet 1024,768,gScreenD,gScreenF
		case 31
			ModeSet gScreenW,gScreenH,8,gScreenF
		case 32
			ModeSet gScreenW,gScreenH,15,gScreenF
		case 33
			ModeSet gScreenW,gScreenH,16,gScreenF
		case 34
			ModeSet gScreenW,gScreenH,24,gScreenF
		case 35
			ModeSet gScreenW,gScreenH,32,gScreenF
		case 16
			d = UI_GetBoxDataPtr(box)
			if (d->checked) Then
				UI_ShowBox(gConsole)
			else
				UI_HideBox(gConsole)
			End If
		case else
		  return 1 '' Msg not processed
		End Select
	case else
		return 1 '' Msg not processed
	End Select
End Function

Function Test1_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Select Case msgid
	Case UI_MSG_MOUSE_CLICK
		Select Case box->id
		Case 1
			UI_HideBox(gTest1)
		case else
			return 1 '' Msg not processed
		End Select
	case else
		return 1 '' Msg not processed
	End Select
End Function

Function Test2_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim scr As UI_SCROLL_T Ptr
	Select Case msgid
	case UI_MSG_PAINT
	  Select case box->id
		case 2
			scr = UI_GetBoxDataPtr(box)
		  UpdateCaption gTest2, 3, "Scroll=" & Str(scr->ival)
		End Select
		return 1
	case UI_MSG_CREATE
	  Select Case box->id
		Case 2
			scr = UI_GetBoxDataPtr(box)
			scr->imin = 0
			scr->imax = 10
			scr->ival = 5
		End Select
	Case UI_MSG_MOUSE_CLICK
		Select Case box->id
		Case 1
			UI_HideBox(gTest2)
		Case 2
			CON_print("Mouse @ " & Str(msgdata->mx) & "," & Str(msgdata->my) & ")")
		case 9
			Dim As UI_BOX_PTR edt1, edt2
			Dim As UI_INPUT_T ptr d1, d2
			Dim tmp as string
			edt1 = UI_GetBoxFromID(box->owner, 6)
			d1 = UI_GetBoxDataPtr(edt1)
			edt2 = UI_GetBoxFromID(box->owner, 7)
			d2 = UI_GetBoxDataPtr(edt2)
			tmp = LINE_BUFFER_GetText(d1->buffer)
			LINE_BUFFER_SetText(d2->buffer, tmp)
		case else
			return 1 '' Msg not processed
		End Select
	case UI_MSG_CHANGE
		CON_print("Change @ " & Str(msgdata->mx) & "," & Str(msgdata->my) & ")")
	case else
		return 1 '' Msg not processed
	End Select
End Function

Function Console_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim r As UI_RECT_T
	static bk As Any Ptr
	'' FIXME: Need mode change broadcast message from GUI back-end
	Select Case msgid
	Case UI_MSG_CREATE
		''bk = ImageCreate(6,9,RGBA(0,0,0,127))
		return 1 '' Msg not processed
	Case UI_MSG_DESTROY
		''ImageDestroy bk
		return 1 '' Msg not processed
	Case UI_MSG_PAINT
		''UI_CallDefaultProc box, msgid, msgdata
  	UI_GetScreenCoords box, @r
		UI_DrawFrame @r, UI_FRAMESTYLE_UP or UI_FRAMESTYLE_FILL
	  Draw_Con r.x + 1, r.y + 1
	Case Else
		return 1 '' Msg not processed
	End Select
End Function

'' --------------------------------------------------------------------------
'' CREATION PROCS
'' --------------------------------------------------------------------------

Function CreateOptions_Dlg(owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm, btn, chk, cap
	Dim c1 As integer = 4
	Dim c2 As Integer = 68
	Dim c3 As Integer = 132

	frm = UI_CreateFrame(owner, 0,10, 10,200,300, @Options_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm,  1, c1, 4 + 24 * 0, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	btn = UI_CreateButton(frm,  2, c1, 4 + 24 * 1, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Quit")
	btn = UI_CreateButton(frm,  3, c1, 4 + 24 * 2, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Test 1")
	btn = UI_CreateButton(frm,  4, c1, 4 + 24 * 3, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Test 2")
	btn = UI_CreateButton(frm,  5, c1, 4 + 24 * 4, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Fullscreen")
	btn = UI_CreateButton(frm,  6, c1, 4 + 24 * 5, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Windowed")
	chk = UI_CreateCheck (frm,  7, c1, 4 + 24 * 6, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "VSync")
	cap = UI_CreateCaption(frm, 8, c1, 4 + 24 * 7, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "VSync")
	cap = UI_CreateCaption(frm, 9, c1, 4 + 24 * 8, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "LastKey")
	chk = UI_CreateCheck (frm, 16, c1, 4 + 24 * 9, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Console")

#ifndef YAGL	
	''btn = UI_CreateButton(frm, 21, c2, 4 + 24 * 3, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "320x200")
#endif
	btn = UI_CreateButton(frm, 22, c2, 4 + 24 * 4, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "640x480")
	btn = UI_CreateButton(frm, 23, c2, 4 + 24 * 5, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "800x600")
	btn = UI_CreateButton(frm, 24, c2, 4 + 24 * 6, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "1024x768")

#ifndef YAGL	
	btn = UI_CreateButton(frm, 31, c3, 4 + 24 * 2, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "8 bit")
	btn = UI_CreateButton(frm, 32, c3, 4 + 24 * 3, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "15 bit")
#endif	

	btn = UI_CreateButton(frm, 33, c3, 4 + 24 * 4, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "16 bit")
	btn = UI_CreateButton(frm, 34, c3, 4 + 24 * 5, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "24 bit")
	btn = UI_CreateButton(frm, 35, c3, 4 + 24 * 6, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "32 bit")


	Function = frm
End Function

Function CreateTest1_Dlg(owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm, btn, cap
	Dim As Integer i, x, y, xx, yy

	frm = UI_CreateFrame(owner,0,220, 10,200,300, @Test1_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm,  1,   4,  4, 64, 16, @Test1_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	cap = UI_CreateCaption(frm, 2,   4, 24, 64, 16, @Test1_BoxProc, UI_BOX_FLAG_NORMAL, "Caption")

	For x = 0 To 2
	  For y = 0 To 4
		  i = 100 + 10 * y + x
			xx = 4 + 64 * x
			yy = 104 + 20 * y
			cap = UI_CreateCaption(frm, i,  xx, yy, 60, 16, @Test1_BoxProc, UI_BOX_FLAG_NORMAL, Str(i))
		Next y
	Next x

	UpdateCaption frm, 100, "Stats"

	UpdateCaption frm, 101, "Time"
	UpdateCaption frm, 102, "Rate"

	UpdateCaption frm, 110, "Input"
	UpdateCaption frm, 120, "Draw"
	UpdateCaption frm, 130, "Update"
	UpdateCaption frm, 140, "Total"

	Function = frm
End Function

Function CreateTest2_Dlg(owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm, btn, vs, cap, edt

	frm = UI_CreateFrame(owner,0,430, 10,200,300, @Test2_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm, 1, 4, 4, 64, 16, @Test2_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	cap = UI_CreateCaption(frm, 3,   4, 24, 64, 16, @Test1_BoxProc, UI_BOX_FLAG_NORMAL, "Scroll=")

	vs = UI_CreateVSCroll(frm, 2, 182,4,10,128, @Test2_BoxProc, UI_BOX_FLAG_NORMAL)

	edt = UI_CreateInput(frm, 6, 8,44,168,12,NULL,UI_BOX_FLAG_NORMAL, "Input1")
	edt = UI_CreateInput(frm, 7, 8,64,168,12,NULL,UI_BOX_FLAG_NORMAL, "Input2")
	edt = UI_CreateEdit(frm, 8, 8,84,168,180,NULL,UI_BOX_FLAG_NORMAL, "Input3")

	btn = UI_CreateButton(frm, 9, 68, 4, 64, 16, @Test2_BoxProc, UI_BOX_FLAG_NORMAL, "Copy")

	Function = frm
End Function

Function CreateConsole_Dlg(owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm
	frm = UI_CreateFrame(groot, 0, 16, 240, CON_maxcol() * fnt->w + 2, CON_maxrow() * fnt->h + 2, @Console_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	UI_HideBox frm
	Function = frm
End Function

'' --------------------------------------------------------------------------
'' MAIN
'' --------------------------------------------------------------------------

''sub mainprog cdecl alias "mainprog" ()

CON_print("Initializing ...")
CON_setlogfile "guidemo.log"
#ifdef YAGL
	ScreenRes 320, 200, 32, 0, -1 
#endif
ModeSet 640,480,8,0
gRoot = UI_CreateRoot(NULL, NULL, UI_BOX_FLAG_NORMAL)
gOptions = CreateOptions_Dlg(gRoot)
gTest1 = CreateTest1_Dlg(gRoot)
	UI_HideBox gTest1
gTest2 = CreateTest2_Dlg(gRoot)
	UI_HideBox gTest2
gConsole = CreateConsole_Dlg(gRoot)
gCapRate = UI_CreateCaption(gRoot, 1, 0, 0, 64, 16, 0, UI_BOX_FLAG_NORMAL, "Rate")
UI_SetFocus(gConsole)
MainLoop
UI_DeleteBox gRoot
UI_Close
FONT_Delete fnt

''End sub

