''  jm_boxes_std_edit.bas - jm_gui
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_boxes_std_edit.bi"

#include "jm_gui.bi"
#include "jm_gui_keys.bi"
#include "jm_boxes.bi"
#include "../jm_font/jm_font.bi"

'' -------------------------------------------------------------------
'' BOX CREATION
'' -------------------------------------------------------------------

Function UI_CreateEdit(ByVal ownerbox As UI_BOX_PTR, byval id As integer, _
	byval x As Integer, byval y As Integer, byval w As Integer, byval h As Integer, _
	ByVal BoxProc As BOXPROC_FUNC_T, ByVal flags As Integer, strCaption As string ) As UI_BOX_PTR
	Dim tmp As UI_BOX_PTR
	tmp = UI_CreateBox(ownerbox, UI_BOX_EDIT, id, x, y, w, h, BoxProc, @UI_DefEditProc_cb, sizeof(UI_EDIT_T), flags)
	If (tmp) Then
		Dim d As UI_EDIT_T Ptr = UI_GetBoxDataPtr(tmp)
		GAP_BUFFER_SetText(d->buffer,strCaption)
		GAP_BUFFER_ClearChanged(d->buffer)
	End If
End Function

'' -------------------------------------------------------------------
'' DEFAULT BOXPROCS
'' -------------------------------------------------------------------

Private sub UpdatePosition(byval r As UI_RECT_T Ptr, ByVal d As UI_EDIT_T Ptr, byval mx as integer, byval my as integer)
	dim cx as integer, cy as integer, xchars as integer
	UI_InflateRect r, -1, -1
	cx = FONT_GetTextWidth("M")
	cy = FONT_GetTextHeight("M")
	xchars = (r->w - (r->w mod cx)) \ cx - 1
	if xchars <= 0 then xchars = 1
	GAP_BUFFER_SetIndex(d->buffer, d->leftindex + ((mx + cx \ 2) \ cx))
end sub

Function UI_DefEditProc_cb (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim r As UI_RECT_T
	Dim d As UI_EDIT_T Ptr = UI_GetBoxDataPtr(box)
	dim cx as integer, cy as integer
	dim nx as integer, ny as integer, xchars as integer, ychars as integer

	If (UI_CallBoxProc(box, msgid, msgdata)) Then

		Select Case msgid
		Case UI_MSG_CREATE
			d->flags = 0
			d->buffer = GAP_BUFFER_Create(1024)
			d->leftindex = 0
			d->topindex = 0
		
		Case UI_MSG_DESTROY
			GAP_BUFFER_Destroy d->buffer
			d->buffer = 0
		
		Case UI_MSG_PAINT
			UI_GetScreenCoords box, @r

			UI_DrawFrame @r, UI_FS_EDIT

			UI_InflateRect @r, -1, -1
			cx = FONT_GetTextWidth("M")
			cy = FONT_GetTextHeight("M")
			xchars = (r.w - (r.w mod cx)) \ cx - 1
			if xchars <= 0 then xchars = 1
			ychars = (r.h - (r.h mod cy)) \ cy - 1
			if ychars <= 0 then ychars = 1

#if 0
			if d->buffer->mlength <= xchars then
				d->leftindex = 0
			elseif d->buffer->mindex = d->buffer->mlength then
				d->leftindex = d->buffer->mlength - xchars
			else
				if d->buffer->mindex < d->leftindex + 1 then
					if d->buffer->mindex < xchars then
						d->leftindex = 0
					else
						d->leftindex = d->buffer->mindex - xchars \ 2
					end if
				elseif d->buffer->mindex > d->leftindex + xchars then
					d->leftindex = d->buffer->mindex - xchars + xchars \ 2
				end if
			end if

			nx = xchars
			if (d->buffer->mlength - d->leftindex) < xchars then
				n = d->buffer->mlength - d->leftindex
			end if

			if d->buffer->mlength > xchars then
				UI_DrawText @r, d->buffer->mdata + d->leftindex, n, UI_GetSysColor(SYSCLR_TEXT), UI_GetSysColor(SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_LEFT
			else
				UI_DrawText @r, d->buffer->mdata + d->leftindex, d->buffer->mlength, UI_GetSysColor(SYSCLR_TEXT), UI_GetSysColor(SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_LEFT ''UI_TEXT_ALIGN_CENTER
			end if

			if UI_GetFocus() = box then
				dim xx = r.x + (d->buffer->mindex - d->leftindex) * cx
				dim yy = r.y
				UI_DrawCaret xx,yy,cx,cy,UI_GetSysColor(SYSCLR_TEXT)
			end if
#endif

		case UI_MSG_MOUSE_DOWN
			if UI_GetCapture = NULL then
				UI_SetCapture box
				UpdatePosition @r, d, msgdata->mx, msgdata->my
			end if
		case UI_MSG_MOUSE_UP
			if UI_GetCapture() = box then
				UpdatePosition @r, d, msgdata->mx, msgdata->my
			end if
			UI_ReleaseCapture
		case UI_MSG_MOUSE_MOVE
			if UI_GetCapture() = box then
				UpdatePosition @r, d, msgdata->mx, msgdata->my
			end if

		Case UI_MSG_KEYPRESS
			dim buf as GAP_BUFFER_T Ptr = d->buffer
			dim ch as integer = msgdata->ky
			Select case ch
			case KEY_LEFT
				if buf->mindex > 0 then buf->mindex -= 1
			case KEY_RIGHT
				''if buf->mindex < buf->mlength then buf->mindex += 1
			case KEY_HOME
				if buf->mindex > 0 then	buf->mindex = 0
			case KEY_END
				''if buf->mindex < buf->mlength then buf->mindex = buf->mlength
			case KEY_BACK
				GAP_BUFFER_BackChar buf
			''case KEY_INSERT
			case KEY_DELETE
				GAP_BUFFER_DeleteChar buf
			case 32 to 126
				GAP_BUFFER_InsertChar buf, ch
			case else
				return 1
			end select
		Case Else
			return 1
		End Select
	else
	  return 1 '' Msg not processed
	End If
End Function


