#ifndef __INCLUDE_JM_GAP_BUFFER_BI__
#define __INCLUDE_JM_GAP_BUFFER_BI__

const GAP_BUFFER_FLAG_CHANGED = 1

Type GAP_BUFFER_T
	mdata as ubyte ptr
	msize as integer
	mflags as integer
	mindex as integer
	mGap1 as integer
	mGap2 as integer
End Type

declare function GAP_BUFFER_Create        (byval startsize as integer) as GAP_BUFFER_T Ptr
declare sub      GAP_BUFFER_Destroy       (byval buf as GAP_BUFFER_T Ptr)
declare sub      GAP_BUFFER_Clear         (byval buf as GAP_BUFFER_T Ptr)
declare function GAP_BUFFER_GetBufferSize (byval buf as GAP_BUFFER_T ptr) As integer
declare sub      GAP_BUFFER_SetBufferSize (byval buf as GAP_BUFFER_T ptr, byval size As integer)

declare function GAP_BUFFER_GetLength     (byval buf as GAP_BUFFER_T ptr) As integer
declare function GAP_BUFFER_GetIndex      (byval buf as GAP_BUFFER_T ptr) As integer
declare sub      GAP_BUFFER_SetIndex      (byval buf as GAP_BUFFER_T ptr, byval Index As integer)

declare sub      GAP_BUFFER_InsertChar    (byval buf as GAP_BUFFER_T Ptr, byval ch As Integer)
declare sub      GAP_BUFFER_BackChar      (byval buf as GAP_BUFFER_T Ptr)
declare sub      GAP_BUFFER_DeleteChar    (byval buf as GAP_BUFFER_T Ptr)
declare function GAP_BUFFER_GetChar       (byval buf as GAP_BUFFER_T Ptr, byval Index As integer) As Integer
declare sub      GAP_BUFFER_SetChar       (byval buf as GAP_BUFFER_T Ptr, byval Index As integer, byval ch As Integer)
declare function GAP_BUFFER_GetText       (byval buf as GAP_BUFFER_T Ptr) As String
declare sub      GAP_BUFFER_SetText       (byval buf as GAP_BUFFER_T Ptr, txt as String)

declare sub      GAP_BUFFER_ClearChanged  (byval buf as GAP_BUFFER_T Ptr)
declare function GAP_BUFFER_IsChanged     (byval buf as GAP_BUFFER_T Ptr) as integer

#endif