''  jm_gui.bas - jm_gui
''	Copyright (C) 2005,2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "jm_gui.bi"

'' From jm_boxes_draw
Declare Sub UI_DrawInit()

'' -------------------------------------------------------------------

#define UI_ALLOC(n_)       Allocate(n_)
#define UI_CALLOC(n_)      Callocate(n_)
#define UI_FREE(p_)        Deallocate (p_)
#define UI_REALLOC(p_, n_) Reallocate(p_, n_)

Dim Shared curr_mx As Integer = 0
Dim Shared curr_my As Integer = 0
Dim Shared curr_mw As Integer = 0
Dim Shared curr_mb As Integer = 0
Dim Shared curr_tm As Double

Dim Shared prev_mx As Integer = 0
Dim Shared prev_my As Integer = 0
Dim Shared prev_mw As Integer = 0
Dim Shared prev_mb As Integer = 0
Dim Shared prev_tm As Double

Dim Shared down_mx As Integer = 0
Dim Shared down_my As Integer = 0
Dim Shared down_tm As Double

Dim Shared drag_mx As Integer = 0
Dim Shared drag_my As Integer = 0

Dim Shared currmsg As UI_MSG_DATA_T

Dim Shared mCap As UI_BOX_PTR = 0

Dim Shared focusBox As UI_BOX_PTR = 0

Declare Function p_InsertBefore(byval a As UI_BOX_PTR, byval b As UI_BOX_PTR) As UI_BOX_PTR
Declare Function p_InsertAfter(byval a As UI_BOX_PTR, byval b As UI_BOX_PTR) As UI_BOX_PTR
Declare Function p_InsertChild(byval a As UI_BOX_PTR, byval b As UI_BOX_PTR) As UI_BOX_PTR
Declare Function p_RemoveItem(byval a As UI_BOX_PTR) As Integer
Declare Function p_FirstItem(byval a As UI_BOX_PTR) As UI_BOX_PTR
Declare Function p_LastItem(byval a As UI_BOX_PTR) As UI_BOX_PTR
Declare Function p_MoveToFirst(byval a As UI_BOX_PTR) As UI_BOX_PTR
Declare Function p_MoveToLast(byval a As UI_BOX_PTR) As UI_BOX_PTR

Declare Function UI_DispatchMsg(ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer

'' -------------------------------------------------------------------
'' INTERNAL STRING FUNCTIONS - for allocating/deallocating captions
'' -------------------------------------------------------------------

Private Function STRING_FREE(ByVal p As Any Ptr) As Any Ptr
	If (p) Then
		UI_FREE(p)
	End If
	Return NULL
End Function

Private Function STRING_REALLOC(ByVal p AS Any Ptr, ByVal n As Integer, ByVal s As UByte Ptr) As Any Ptr
	Dim sn As UShort Ptr, sd As UByte Ptr, i As UShort, size As UShort
	If n > 0 Then
		size = (((n + 1) + 3) And (Not 3))
		If (p) Then
			sn = CPtr(UShort Ptr, p)
			If (*sn < size) Then
				sn = UI_REALLOC(p, sizeof(UShort) * 2 + size)
				If (sn) Then
					sn[0] = size
					sn[1] = n
				End If
			Else
				sn[1] = n
			End If
		Else
			sn = UI_CALLOC(sizeof(UShort) * 2 + size)
			If (sn) Then
				sn[0] = size
				sn[1] = n
			End If
		End If
		If (sn) Then
			sd = CPtr(UByte Ptr, sn + 2)
			For i = 0 to n - 1
				sd[i] = s[i]
			Next i
			sd[n] = 0
		End If
		Return sn
	End If
	return STRING_FREE(p)
End Function

Private Function STRING_ALLOC(ByVal n As Integer, ByVal s As UByte Ptr) As Any Ptr
	return STRING_REALLOC(0, n, s)
End Function

Private Function STRING_COPY(ByVal p As any Ptr) As String
	Dim s As String, d As UByte Ptr, n As UShort
	Dim sn As UShort Ptr, sd As UByte Ptr, i As UShort
	If (p) Then
		sn = CPtr(UShort Ptr, p)
		n = sn[1]
		If (n > 0) Then
			sd = CPtr(UByte Ptr, sn + 2)
			s = String(n, 0)
			d = StrPtr(s)
			For i = 0 to n - 1
				d[i] = sd[i]
			Next i
		End If
	End If
	return s
End Function

'' -------------------------------------------------------------------
'' RECT FUNCTIONS
'' -------------------------------------------------------------------

Function UI_SetRect( byval rec As UI_RECT_T Ptr, byval x As Integer, byval y As Integer, byval w As Integer, byval h As Integer ) As Integer
	rec->x = x
	rec->y = y
	rec->w = w
	rec->h = h
	Return True
End Function

Function UI_SetRectEmpty( byval rec As UI_RECT_T Ptr ) As Integer
	rec->x = 0
	rec->y = 0
	rec->w = 0
	rec->h = 0
	Return True
End Function

Function UI_CopyRect( byval dst As UI_RECT_T Ptr, byval src As UI_RECT_T Ptr ) As Integer
	*dst = *src
	Return True
End Function

Function UI_OffsetRect( byval rec As UI_RECT_T Ptr, byval dx As Integer, byval dy As Integer ) As Integer
	rec->x += dx
	rec->y += dy
	Return True
End Function

Function UI_PositionRect( byval rec As UI_RECT_T Ptr, byval x As Integer, byval y As Integer ) As Integer
	rec->x = x
	rec->y = y
	Return True
End Function

Function UI_ResizeRect( byval rec As UI_RECT_T Ptr, byval w As Integer, byval h As Integer ) As Integer
	rec->w = w
	rec->h = h
	Return True
End Function

Function UI_InflateRect( byval rec As UI_RECT_T Ptr, byval dx As Integer, byval dy As Integer ) As Integer
	rec->x -= dx
	rec->y -= dy
	rec->w += dx * 2
	rec->h += dy * 2
	Return True
end function

Function UI_SizeRect( byval rec As UI_RECT_T Ptr ) As Integer
	rec->x = 0
	rec->y = 0
End Function

Function UI_IsPointInRect (byval rec AS UI_RECT_T Ptr, byval x AS Integer, byval y AS Integer) as Integer
	UI_IsPointInRect = 0
	If x >= rec->x Then
		If y >= rec->y Then
			If x < rec->x + rec->w Then
				If y < rec->y + rec->h Then
					return 1
				End If
			End If
		End If
	End If
End Function

'' -------------------------------------------------------------------
'' PRIVATE LIST FUNCTIONS
''
''   These Functions *do not* allocate/deallocate memory
''   They only operate the relational pointers in pre-allocated
'' UI_BOX_T objects
'' -------------------------------------------------------------------

Private Function p_InsertBefore(byval a As UI_BOX_PTR, byval b As UI_BOX_PTR) As UI_BOX_PTR
	'' Insert b before a
	If (a) Then
		If (b) Then
			If (a<>b) Then
				b->Prev = a->Prev
				b->Next = a
				If (a->Prev) Then
					a->Prev->Next = b
				End If
				a->Prev = b
				b->Owner = a->Owner
				'' Owner->Child Must Always point to start of list
				If (b->Owner) Then
					If (b->Prev = 0) Then
						b->Owner->Child = b
					End If
				End If
				Return b
			End If
		End If
	End If
	Return NULL
End Function

Private Function p_InsertAfter(byval a As UI_BOX_PTR, byval b As UI_BOX_PTR) As UI_BOX_PTR
	'' Insert b after a
	If (a) Then
		If (b) Then
			If (a<>b) Then
				b->Prev = a
				b->Next = a->Next
				If (a->Next) Then
					a->Next->Prev = b
				End If
				a->Next = b
				b->Owner = a->Owner
				Return b
			End If
		End If
	End If
	Return NULL
End Function

Private Function p_InsertChild(byval a As UI_BOX_PTR, byval b As UI_BOX_PTR) As UI_BOX_PTR
	Dim tmp As UI_BOX_PTR
	If (a) Then
		If (b) Then
			If (a<>b) Then
				if (a->Child) then
					tmp = p_LastItem(a->Child)
					p_InsertAfter tmp, b
				Else
					a->Child = b
					b->Owner = a
					'' b->Prev = NULL  '' Needed?
					'' b->Next = NULL  '' Needed?
					'' b->Child = NULL '' Needed?
				End If
				Return b
			End If
		End If
	End If
	Return NULL
End Function

Private Function p_RemoveItem(byval a As UI_BOX_PTR) As Integer
	If (a) Then
		If (a->Prev) Then
			a->Prev->Next = a->Next
		End If
		If (a->Next) Then
			a->Next->Prev = a->Prev
		End If
		'' Owner->Child Must Always point to start of list
		If (a->Owner) Then
			If (a->Owner->Child = a) Then
				a->Owner->Child = a->Next
			End If
		End If
		a->Owner = NULL '' Needed
		a->Prev = NULL  '' Needed
		a->Next = NULL  '' Needed
		Return True
	End If
	Return False
End Function

Private Function p_FirstItem(byval a As UI_BOX_PTR) As UI_BOX_PTR
	Dim b As UI_BOX_PTR = a
	If (b) Then
		Do While b->Prev
			b = b->Prev
		Loop
	End If
	Return b
End Function

Private Function p_LastItem(byval a As UI_BOX_PTR) As UI_BOX_PTR
	Dim b As UI_BOX_PTR = a
	If (b) Then
		Do While b->Next
			b = b->Next
		Loop
	End If
	Return b
End Function

Function p_MoveToFirst(byval a As UI_BOX_PTR) As UI_BOX_PTR
	If (a) Then
		Dim b As UI_BOX_PTR = p_FirstItem(a)
		If (b) Then
			If (a <> b) Then
				' Remove the item from the list
				If (a->Prev) Then
					a->Prev->Next = a->Next
				End If
				If (a->Next) Then
					a->Next->Prev = a->Prev
				End If
				' Insert it at the beginning
				a->prev = NULL
				a->next = b
				b->prev = a
				' Make sure that owner->child points to start of list
				If (a->owner) Then
					a->owner->child = a
				End If
			End If
		End If
	End If
	Return a
End Function

Function p_MoveToLast(byval a As UI_BOX_PTR) As UI_BOX_PTR
	If (a) Then
		Dim b As UI_BOX_PTR = p_LastItem(a)
		If (b) Then
			If (a <> b) Then
				' Remove the item from the list
				If (a->Prev) Then
					a->Prev->Next = a->Next
				End If
				If (a->Next) Then
					a->Next->Prev = a->Prev
				End If
				If (a->owner) Then
					If (a->owner->child = a) Then
						a->owner->child = a->Next
					End If
					a->owner->child = p_FirstItem(a)
				End If
				' Insert it at the end
				a->prev = b
				a->next = NULL
				b->next = a
			End If
		End If
	End If
	Return a
End Function


'' -------------------------------------------------------------------
'' UI MANAGER
'' -------------------------------------------------------------------

Sub UI_Init()
	UI_DrawInit	
End Sub

Sub UI_Close()
''
'' FIXME: Track created boxes and automatically unload
End Sub

Function UI_CreateBox(byval ownerbox As UI_BOX_PTR, _
	byval boxType As Integer, byval id As integer, _
	byval x As Integer, byval y As Integer, byval w As Integer, byval h As Integer, _
	ByVal BoxProc As BOXPROC_FUNC_T, _
	ByVal DefProc As BOXPROC_FUNC_T, _
	ByVal extraDataSize As Integer, ByVal flags As Integer ) As UI_BOX_PTR

	'' FIXME: Add Flags to set zorder

	Dim tmp As UI_BOX_PTR, ret As integer

	tmp = UI_CALLOC(sizeof(UI_BOX_T) + ((extraDataSize + 3) And (Not 3)))
	If (tmp = 0) Then
		Return NULL
	End If

	tmp->Owner = NULL
	tmp->Prev = NULL
	tmp->Next = NULL
	tmp->Child = NULL
	tmp->extraDataSize = extraDataSize

	If (ownerbox) Then
		p_InsertChild ownerbox, tmp
		tmp->rec.x = ownerbox->rec.x + x
		tmp->rec.y = ownerbox->rec.y + y
		tmp->rec.w = w
		tmp->rec.h = h
	Else
		tmp->rec.x = x
		tmp->rec.y = y
		tmp->rec.w = w
		tmp->rec.h = h
	End If

	tmp->BoxType = boxtype
	tmp->id = id
	tmp->Caption = NULL
	tmp->Flags = flags
	tmp->BoxProc = boxproc
	tmp->DefProc = defproc

	ret = UI_DispatchMsg(tmp, UI_MSG_CREATE, NULL)
	ret = UI_DispatchMsg(tmp, UI_MSG_MOVE, NULL)
	ret = UI_DispatchMsg(tmp, UI_MSG_SIZE, NULL)
	Return tmp
End Function

Function UI_DeleteBox(byval box As UI_BOX_PTR) As Integer
	Dim tmp As UI_BOX_PTR, tmp2 As UI_BOX_PTR, ret As Integer
	Dim backtrack As Integer

	If (box = 0) Then
		Return False
	End If

	tmp = box
	BackTrack = 0
	Do While (tmp)
		If (backtrack = 0) Then  
			If (tmp->child) Then
				tmp = p_LastItem(tmp->child)
			else
				backtrack = 1
			End If
		Else
			'' Delete the box

			If (tmp = box) Then
				tmp2 = NULL
			Elseif tmp->prev Then
			  tmp2 = tmp->prev
			elseif tmp->owner Then
			  tmp2 = tmp->owner
			else
			  tmp2 = NULL
			End IF

			ret = UI_DispatchMsg(tmp, UI_MSG_DESTROY, NULL)

			'' Free the caption string first
			UI_FREE(tmp->caption)

			p_RemoveItem tmp

			tmp = tmp2
			backtrack = 0
		End If
	Loop

	Return True
End Function

Function UI_ShowBox(byval box As UI_BOX_PTR) As Integer
	If (box) Then
		If (box->flags And UI_BOX_FLAG_VISIBLE) = 0 Then
			box->flags = box->flags Or UI_BOX_FLAG_VISIBLE
			'':Refresh
		End If
		UI_SetFocus(box) '' FIXME: should be option
	End If
	Return True
End Function

Function UI_HideBox(byval box As UI_BOX_PTR) As Integer
	If (box) Then
		If (box->flags And UI_BOX_FLAG_VISIBLE) Then
			box->flags = box->flags And (Not UI_BOX_FLAG_VISIBLE)
			'':Refresh
		End If
	End If
	Return True
End Function

Function UI_EnableBox(byval box As UI_BOX_PTR) As Integer
	'' FIXME: Enable children as needed
	If (box) Then
		If (box->flags And UI_BOX_FLAG_DISABLED) Then
			box->flags = box->flags And (Not UI_BOX_FLAG_DISABLED)
			'':Refresh
		End If
	End If
	Return True
End Function

Function UI_DisableBox(byval box As UI_BOX_PTR) As Integer
	'' FIXME: Disable children as needed
	If (box) Then
		If (box->flags And UI_BOX_FLAG_DISABLED) = 0 Then
			box->flags = box->flags Or UI_BOX_FLAG_DISABLED
			'':Refresh
		End If
	End If
	Return True
End Function

Function UI_SetBoxOrder(byval box As UI_BOX_PTR, byval Order As Integer) As Integer
	Dim tmp As UI_BOX_PTR
	If (box) Then
		Select Case Order
		Case UI_ORDER_UP        '' Swap With Previous
			tmp = box->Prev
			If (tmp) Then
				p_RemoveItem box
				p_InsertBefore tmp, box
			End If
		Case UI_ORDER_DOWN      '' Swap With Next
			tmp = box->Next
			If (tmp) Then
				p_RemoveItem box
				p_InsertAfter tmp, box
			End If
		Case UI_ORDER_TOP       '' Move to First
			tmp = p_FirstItem(box)
			If (tmp <> box) Then
				p_RemoveItem box
				p_InsertBefore tmp, box
			End If
		Case UI_ORDER_BOTTOM    '' Move to Last
			tmp = p_LastItem(box)
			If (tmp <> box) Then
				p_RemoveItem box
				p_InsertAfter tmp, box
			End If
		End Select
	End If
	Return False
End Function

Function UI_GetBoxDataPtr(byval box As UI_BOX_PTR) As Any Ptr
	If (box) Then
		If (box->extraDataSize > 0) Then
			Return @box->extraDataSize + 1
		End If
	End If
	Return NULL
End Function

Function UI_GetParentBox(byval box As UI_BOX_PTR) As UI_BOX_PTR
	If (box) Then
		If (box->owner) Then
			return box->owner
		End If
	End If
	return NULL
End Function

Function UI_GetBoxFromID(byval box As UI_BOX_PTR, ByVal id As Integer) As UI_BOX_PTR
	Dim tmp As UI_BOX_PTR
	If (box) Then
		tmp = box->child
		Do While (tmp)
			If (tmp->id = id) Then
				Exit Do
			End If
			tmp = tmp->next
		Loop
		return tmp
	End If
	return NULL
End Function

'' -------------------------------------------------------------------
'' UI DISPATCHERS AND HOOKS
'' -------------------------------------------------------------------

Private Function UI_DispatchMsg(ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim ret As Integer = 1
	''If (ret) Then
	''	If (box->BoxProc) Then
	''		ret = box->BoxProc(box, msgid, msgdata)
	''	End If
	''End If
	If (ret) Then
	  If (box->DefProc) Then
			ret = box->DefProc(box, msgid, msgdata)
		End If
	End If
	return ret
End Function

Function UI_CallDefaultProc(ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim ret As Integer = 1
	''If (ret) Then
		If (box) Then
			If (box->DefProc) Then
				ret = box->DefProc(box, msgid, msgdata)
			End If
		End If
	''End if
	Function = ret
End Function

Function UI_CallBoxProc(ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim ret As Integer = 1
	''If (ret) Then
		If (box) Then
			If (box->BoxProc) Then
				ret = box->BoxProc(box, msgid, msgdata)
			End If
		End If
	''End if
	Function = ret
End Function

'' -------------------------------------------------------------------
'' UI HELPERS
'' -------------------------------------------------------------------

Function UI_PositionBox(byval box As UI_BOX_PTR, _
	byval x As integer, byval y As integer) As Integer

	Dim dx As Integer, dy As Integer
	Dim tmp As UI_BOX_PTR
	Dim backtrack As Integer

	If (box) Then
		If (box->owner) Then
			dx = x - (box->rec.x - box->owner->rec.x)
			dy = y - (box->rec.y - box->owner->rec.y)
		Else
			dx = x - box->rec.x
			dy = y - box->rec.y
		End If

		tmp = box
		backtrack = 0
		Do while (tmp)
			If (backtrack = 0) Then
				UI_OffsetRect @tmp->rec, dx, dy
				If (tmp->child) Then
					tmp = tmp->child
				ElseIf (tmp = box) Then
					Exit Do
				ElseIf (tmp->next) Then
					tmp = tmp->next
				Else
					tmp = tmp->owner
					backtrack = 1
				End if
			Else
				If (tmp = box) Then
					Exit Do
				ElseIf (tmp->next) Then
					tmp = tmp->next
					backtrack = 0
				Else
					tmp = tmp->owner
				End if
			End If
		Loop
		UI_DispatchMsg(box, UI_MSG_MOVE, NULL)
		Return True
	End If
	Return False
End Function

Function UI_ResizeBox(byval box As UI_BOX_PTR, _
	byval w As integer, byval h As integer) As Integer
	If ((w > 0) And (h > 0)) Then
		UI_ResizeRect @box->rec, w, h
		UI_DispatchMsg(box, UI_MSG_SIZE, NULL)
		Return True
	End If
	Return False
End Function

Function UI_MoveBox(byval box As UI_BOX_PTR, _
	byval x As integer, byval y As integer, _
	byval w As integer, byval h As integer) As Integer

	If ((w > 0) And (h > 0)) Then
		UI_PositionBox box, x, y
		UI_ResizeBox   box, w, h
		Return True
	End If
	Return False
End Function

Sub UI_SetCaption(byval box As UI_BOX_PTR, s As string)
	Dim n As Integer
	If (box) Then
		n = len(s)
		box->caption = STRING_REALLOC(box->caption, n, StrPtr(s))
	End If
End Sub

Function UI_GetCaption(byval box As UI_BOX_PTR) As String
	If (box) Then
		return STRING_COPY(box->Caption)
	End If
End Function

'' -------------------------------------------------------------------
'' BOX COORDS
'' -------------------------------------------------------------------

Function UI_GetScreenCoords(byval box As UI_BOX_PTR, byval rec As UI_RECT_T Ptr) As Integer
	If (box) Then
		UI_CopyRect rec, @box->rec
		return True
	End If
	UI_SetRectEmpty rec
	return False
End Function

Function UI_GetParentCoords(byval box As UI_BOX_PTR, byval rec As UI_RECT_T Ptr) As Integer
	Function = False
	If (box) Then
		Function = UI_GetScreenCoords(box->owner, rec)
	Else
		UI_SetRectEmpty rec
	EndIf
End Function

Function UI_GetBoxCoords(byval box As UI_BOX_PTR, byval rec As UI_RECT_T Ptr) As Integer
	If (box) Then
		rec->x = 0
		rec->y = 0
		rec->w = box->rec.w
		rec->h = box->rec.h
		return True
	Endif
	return False
End Function

'' x and y are absolute
Function UI_GetBoxFromXY(byval box As UI_BOX_PTR, byval x AS Integer, byval y AS Integer) As UI_BOX_PTR
	'' Use XY to determine the box by walking the multiway tree from
	Dim a As UI_BOX_PTR = NULL
	Dim tmp As UI_BOX_PTR = box
	Do While (tmp)
		If (tmp->flags And UI_BOX_FLAG_VISIBLE) Then
			If (tmp->flags And UI_BOX_FLAG_ROOT) Then
				a = tmp
				tmp = a->child
			Else
				If UI_IsPointInRect(@tmp->rec, x, y) Then
					a = tmp
					tmp = a->child
				Else
					tmp = tmp->next
				End If
			End If
		Else
			tmp = tmp->next
		End If
	Loop
	Return a
End Function


'' -------------------------------------------------------------------
'' UI INPUT
'' -------------------------------------------------------------------

Function UI_SetCapture(byval box As UI_BOX_PTR) As UI_BOX_PTR
	Dim tmp As UI_BOX_PTR
	tmp = mCap
	If (box) Then
		mCap = box
		return tmp  
	End If
	return NULL
End Function

Function UI_ReleaseCapture() As Integer
	mCap = NULL
	return True
End Function

Function UI_GetCapture() As UI_BOX_PTR
	return mCap
End Function

Function UI_BeginDrag(byval box As UI_BOX_PTR, ByVal x As Integer, ByVal y As Integer) As UI_BOX_PTR
  drag_mx = x
	drag_my = y
	Return UI_SetCapture(box)
End Function

Function UI_EndDrag(byval box As UI_BOX_PTR, ByVal x As Integer, ByVal y As Integer) As Integer
	Return UI_ReleaseCapture()
End Function

Function UI_Drag(byval box As UI_BOX_PTR, ByVal x As Integer, ByVal y As Integer) As UI_BOX_PTR
	Dim mx As Integer, my As Integer
	Dim r As UI_RECT_T
	If UI_GetCapture() = box Then
		UI_GetMouseCoords mx, my
		UI_GetParentCoords box, @r
		UI_PositionBox box, mx - drag_mx - r.x, my - drag_my - r.y
	End If
End Function


Function UI_Setfocus(byval box As UI_BOX_PTR) As UI_BOX_PTR
	Dim last As UI_BOX_PTR = focusBox
	Dim tmp As UI_BOX_PTR = box
	Do While(tmp)
		p_MoveToFirst tmp
		tmp = tmp->owner
	Loop
	'' FIXME: Send lost focus Msg?
	focusBox = box
	return last
End Function

Function UI_GetFocus() As UI_BOX_PTR
	return focusBox
End Function

Function UI_GetMouseCoords(ByRef x As Integer, ByRef y As Integer) As Integer
	x = curr_mx
	y = curr_my
End Function

Function UI_UpdateMouseInfo(byval box As UI_BOX_PTR, byval mx As Integer, byval my As Integer, byval mw AS Integer, byval mb As Integer) As Integer
	Dim tmp As UI_BOX_PTR, ret As Integer
	Dim lastcap As UI_BOX_PTR
	function = 1
	If mX >= 0 And mY >= 0 Then
		if mCap Then
			tmp = mCap
		Else
			tmp = UI_GetBoxFromXY(box, mX, mY)
		End If

		If (tmp) Then

			prev_mx = curr_mx
			prev_my = curr_my
			prev_mw = curr_mw
			prev_mb = curr_mb
			prev_tm = curr_tm

			curr_mx = mx
			curr_my = my
			curr_mw = mw
			curr_mb = mb
			curr_tm = Timer

			currmsg.mx = curr_mx - tmp->rec.x
			currmsg.my = curr_my - tmp->rec.y
			currmsg.mw = curr_mw
			currmsg.mb = curr_mb

			If ((prev_mb And 1) = 0) And ((curr_mb And 1) = 1) Then
				If ((tmp <> focusBox) And (mCap = 0)) Then
					UI_Setfocus tmp
				End If

				currmsg.mb = 1
				down_mx = curr_mx
				down_my = curr_my
				down_tm = curr_tm
				' FIXME: Autoset capture/drag here based on a box style flag?
				ret = UI_DispatchMsg(tmp, UI_MSG_MOUSE_DOWN, @currmsg)
			End If

			If ((prev_mb And 1) = 1) And ((curr_mb And 1) = 0) Then
				'' FIXME: Detect double click
				currmsg.mb = 1
				lastcap = UI_GetCapture()
				ret = UI_DispatchMsg(tmp, UI_MSG_MOUSE_UP, @currmsg)
				If tmp = lastcap Then
					If UI_IsPointInRect(@tmp->rec, curr_mx, curr_my) Then
						ret = UI_DispatchMsg(tmp, UI_MSG_MOUSE_CLICK, @currmsg)
					End If
				End If
			End If

			If (prev_mx <> curr_mx) Or (prev_my <> curr_my) Then
				ret = UI_DispatchMsg(tmp, UI_MSG_MOUSE_MOVE, @currmsg)
			End If

			If (tmp->flags And UI_BOX_FLAG_ROOT) Then
				Function = 0
			End If

		End If
	End If
End Function

Function UI_UpdateKeyInfo(byval box As UI_BOX_PTR, byval ky As Integer) As Integer
	Dim tmp As UI_BOX_PTR, ret As Integer = 1
	currmsg.ky = ky
	'' FIXME: add flag to boxes for allow key events
	if (box) then
		tmp = box 
	else
		tmp = focusBox
	end if
	if (tmp) then
		ret = UI_DispatchMsg(tmp, UI_MSG_KEYPRESS, @currmsg)
	end if
	function = ret
End Function

'' -------------------------------------------------------------------
'' UI DRAWING
'' -------------------------------------------------------------------

Function UI_Draw(byval box As UI_BOX_PTR, flags As Integer) As Integer
	Dim ret As Integer = 0
	Dim tmp As UI_BOX_PTR = box
	Dim backtrack As Integer = 0
	'' FIXME: Add NoDrawSiblings/NoDrawChildren in flags parameter
	Do While (tmp)
		If ((backtrack = 0) And ((tmp->flags And UI_BOX_FLAG_VISIBLE) <> 0)) Then  
			ret = UI_DispatchMsg(tmp, UI_MSG_PAINT, NULL)
			If (tmp->child) Then
				tmp = p_LastItem(tmp->child)
				backtrack = 0
			ElseIf (tmp = box) Then
				Exit Do
			ElseIf (tmp->prev) Then
				tmp = tmp->prev
				backtrack = 0
			Else
				tmp = tmp->owner
				backtrack = 1
			End If
		Else
			If (tmp = box) Then
				Exit Do
			ElseIf (tmp->prev) Then
				tmp = tmp->prev
				backtrack = 0
			Else
				tmp = tmp->owner
				backtrack = 1
			End If
		End if
	Loop
	return ret
End Function

