#ifndef __INCLUDE_JM_LINE_BUFFER_BI__
#define __INCLUDE_JM_LINE_BUFFER_BI__

const LINE_BUFFER_FLAG_CHANGED = 1

Type LINE_BUFFER_T
	mdata as ubyte Ptr
	msize as integer
	mflags as integer
	mindex as integer
	mlength as integer
End Type


declare function LINE_BUFFER_Create       (byval maxsize as integer) as LINE_BUFFER_T Ptr
declare sub      LINE_BUFFER_Destroy      (byval buf as LINE_BUFFER_T Ptr)
declare sub      LINE_BUFFER_Clear        (byval buf as LINE_BUFFER_T Ptr)
declare function LINE_BUFFER_GetBufferSize(byval buf as LINE_BUFFER_T ptr) As integer
declare sub      LINE_BUFFER_SetBufferSize(byval buf as LINE_BUFFER_T ptr, byval size As integer)

declare function LINE_BUFFER_GetLength    (byval buf as LINE_BUFFER_T Ptr) as integer
declare function LINE_BUFFER_GetIndex     (byval buf as LINE_BUFFER_T Ptr) as integer
declare function LINE_BUFFER_SetIndex     (byval buf as LINE_BUFFER_T Ptr, byval index as integer)

declare sub      LINE_BUFFER_InsertChar   (byval buf as LINE_BUFFER_T Ptr, byval ch as integer)
declare sub      LINE_BUFFER_BackChar     (byval buf as LINE_BUFFER_T Ptr)
declare sub      LINE_BUFFER_DeleteChar   (byval buf as LINE_BUFFER_T Ptr)
declare function LINE_BUFFER_GetChar      (byval buf as LINE_BUFFER_T Ptr, byval Index As integer) As Integer
declare sub      LINE_BUFFER_SetChar      (byval buf as LINE_BUFFER_T Ptr, byval Index As integer, byval ch As Integer)
declare function LINE_BUFFER_GetText      (byval buf as LINE_BUFFER_T Ptr) as string
declare sub      LINE_BUFFER_SetText      (byval buf as LINE_BUFFER_T Ptr, txt as String)

declare sub      LINE_BUFFER_ClearChanged (ByVal buf as LINE_BUFFER_T Ptr)
declare function LINE_BUFFER_IsChanged    (ByVal buf as LINE_BUFFER_T Ptr) as integer
#endif