##################################################################

FBCMPFLAGS := -c -arch 486
FBLNKFLAGS :=

ifdef ERRORTYPE
  ifeq ($(ERRORTYPE),1)
    FBCMPFLAGS += -e
  else
    ifeq ($(ERRORTYPE),2)
      FBCMPFLAGS += -ex
    else
      ifeq ($(ERRORTYPE),3)
        FBCMPFLAGS += -exx
      endif
    endif
  endif
endif

ifdef DEBUG
	ifeq ($(DEBUG),1)
    FBCMPFLAGS += -v -g
    FBLNKFLAGS += -v -g
	endif
endif

ifdef PROFILE
	ifeq ($(PROFILE),1)
    FBCMPFLAGS += -profile
    FBLNKFLAGS += -profile
	endif
endif

ifdef DJGPP
    TARGET := dos
else
    TARGET := win32
endif

##################################################################


ifeq ($(TARGET),dos)
	FBC := fbc_dos.exe
else
	FBC := fbc.exe
endif

## FIXME: check for $(main) and $(sources)

ifndef $(main)
	main := $(firstword $(sources))
else
	sources := $(main) $(sources)
endif

ifndef exename
exename = $(subst .bas,.exe,$(main))
else
exename := $(addsuffix .exe,$(basename $(exename)))
endif

ifndef objpath
objpath = ./obj
endif

objects := $(addprefix $(objpath)/, $(addsuffix .o,$(basename $(notdir $(sources)))))
headers := $(wildcard *.bi)

FBCMPFLAGS += -m $(subst .bas,,$(main))

ifeq ($(TARGET),dos)
  FBCMPFLAGS += -t dos
	ifeq ($(USEFBGFX),1)
		LIBS_EXTRA += -l fbgfx
	endif
	ifeq ($(UseFMOD),1)
		LIBS_EXTRA += -l fmod
	endif
endif

ifeq ($(TARGET),win32)
	LIBS_EXTRA := -l user32
	ifeq ($(USEYAGL),1)
		ifeq ($(USEFBGFX),1)
			LIBS_EXTRA += -l fbgfx
		endif
#		ifdef DEBUG
#			LIBS_EXTRA += -l yaglwrapperd
#		else
			LIBS_EXTRA += -l yaglwrapper
#		endif
		LIBS_EXTRA += -l ws2_32 -l opengl32 -l c++util -l mingwex -l gdi32 -l winmm -l glfw2.5.0
		FBCMPFLAGS += -d YAGL
	endif
	ifeq ($(USEFBGFX),1)
		LIBS_EXTRA += -l fbgfx -l gdi32 -l winmm
	endif
	ifeq ($(UseFMOD),1)
		LIBS_EXTRA += -l fmod
	endif
endif


findsource = $(firstword $(foreach xxx, $(sources), $(if $(findstring $(1),$(xxx)),$(xxx))))

##################################################################

all : checkdirs $(exename)

$(objpath)/%.o : $(sources) $(headers)
	$(FBC) -c -m $(subst .bas,,$(main)) $(FBCMPFLAGS) $(call findsource,$*.bas) -o $@

##	$(FBC) -c -m $(subst .bas,,$(main)) $(FBCMPFLAGS) $< -o $@
##
## In order to build sources from a remote directory to an object in
## a remote directory, the above 'findsource' call expression is used.
## The expression will not behave correctly if there are two sources
## with the same name in multiple directories.
##

$(exename) : $(objects)
	$(FBC) $(FBLNKFLAGS) -a $(objects) $(LIBS_EXTRA) -x $@

$(objpath) :
	mkdir $(objpath)
#	mkdir $(subst /,\,$(objpath))

.PHONY: checkdirs
checkdirs : $(objpath)

.PHONY : clean
clean :
	rm -f $(objects)

.PHONY : realclean
realclean :
	rm -f $(objects)
	rm -f $(exename)

.PHONY : dist
dist : 
	mkdir dist
